// This file is part of Ghost Network.

// Ghost Network is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Ghost Network is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Ghost Network.  If not, see <http://www.gnu.org/licenses/>.

//! Autogenerated weights for `ghost_slow_clap`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 32.0.0
//! DATE: 2025-06-17, STEPS: `50`, REPEAT: `20`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `ghostown`, CPU: `Intel(R) Core(TM) i3-2310M CPU @ 2.10GHz`
//! WASM-EXECUTION: `Compiled`, CHAIN: `Some("casper-dev")`, DB CACHE: 1024

// Executed Command:
// ./target/release/ghost
// benchmark
// pallet
// --chain=casper-dev
// --steps=50
// --repeat=20
// --pallet=ghost_slow_clap
// --extrinsic=*
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/casper/src/weights/ghost_slow_clap.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(missing_docs)]

use frame_support::{
    traits::Get,
    weights::{Weight, constants::RocksDbWeight}
};
use core::marker::PhantomData;

pub trait WeightInfo {
    fn slow_clap() -> Weight;
    fn self_applause()-> Weight;
}

/// Weight functions for `ghost_slow_clap`.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	/// Storage: `GhostSlowClaps::Authorities` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Authorities` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ReceivedClaps` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ReceivedClaps` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ClapsInSession` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ClapsInSession` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ApplausesForTransaction` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ApplausesForTransaction` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::NullifyNeeded` (r:1 w:0)
	/// Proof: `GhostNetworks::NullifyNeeded` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::GatekeeperAmount` (r:1 w:1)
	/// Proof: `GhostNetworks::GatekeeperAmount` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::BridgedImbalance` (r:1 w:1)
	/// Proof: `GhostNetworks::BridgedImbalance` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::AccumulatedCommission` (r:1 w:1)
	/// Proof: `GhostNetworks::AccumulatedCommission` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `System::Account` (r:1 w:1)
	/// Proof: `System::Account` (`max_values`: None, `max_size`: Some(128), added: 2603, mode: `MaxEncodedLen`)
	fn slow_clap() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `355`
		//  Estimated: `3820`
		// Minimum execution time: 211_154_000 picoseconds.
		Weight::from_parts(215_420_000, 0)
			.saturating_add(Weight::from_parts(0, 3820))
			.saturating_add(T::DbWeight::get().reads(10))
			.saturating_add(T::DbWeight::get().writes(7))
	}
	/// Storage: `GhostSlowClaps::ReceivedClaps` (r:1 w:0)
	/// Proof: `GhostSlowClaps::ReceivedClaps` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::Authorities` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Authorities` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ApplausesForTransaction` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ApplausesForTransaction` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::NullifyNeeded` (r:1 w:0)
	/// Proof: `GhostNetworks::NullifyNeeded` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::GatekeeperAmount` (r:1 w:1)
	/// Proof: `GhostNetworks::GatekeeperAmount` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::BridgedImbalance` (r:1 w:1)
	/// Proof: `GhostNetworks::BridgedImbalance` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::AccumulatedCommission` (r:1 w:1)
	/// Proof: `GhostNetworks::AccumulatedCommission` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `System::Account` (r:1 w:1)
	/// Proof: `System::Account` (`max_values`: None, `max_size`: Some(128), added: 2603, mode: `MaxEncodedLen`)
	fn self_applause() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `655`
		//  Estimated: `4120`
		// Minimum execution time: 208_453_000 picoseconds.
		Weight::from_parts(212_038_000, 0)
			.saturating_add(Weight::from_parts(0, 4120))
			.saturating_add(T::DbWeight::get().reads(9))
			.saturating_add(T::DbWeight::get().writes(5))
	}
}

impl WeightInfo for () {
	/// Storage: `GhostSlowClaps::Authorities` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Authorities` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ReceivedClaps` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ReceivedClaps` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ClapsInSession` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ClapsInSession` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ApplausesForTransaction` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ApplausesForTransaction` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::NullifyNeeded` (r:1 w:0)
	/// Proof: `GhostNetworks::NullifyNeeded` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::GatekeeperAmount` (r:1 w:1)
	/// Proof: `GhostNetworks::GatekeeperAmount` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::BridgedImbalance` (r:1 w:1)
	/// Proof: `GhostNetworks::BridgedImbalance` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::AccumulatedCommission` (r:1 w:1)
	/// Proof: `GhostNetworks::AccumulatedCommission` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `System::Account` (r:1 w:1)
	/// Proof: `System::Account` (`max_values`: None, `max_size`: Some(128), added: 2603, mode: `MaxEncodedLen`)
	fn slow_clap() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `355`
		//  Estimated: `3820`
		// Minimum execution time: 211_154_000 picoseconds.
		Weight::from_parts(215_420_000, 0)
			.saturating_add(Weight::from_parts(0, 3820))
			.saturating_add(RocksDbWeight::get().reads(10))
			.saturating_add(RocksDbWeight::get().writes(7))
	}
	/// Storage: `GhostSlowClaps::ReceivedClaps` (r:1 w:0)
	/// Proof: `GhostSlowClaps::ReceivedClaps` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::Authorities` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Authorities` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ApplausesForTransaction` (r:1 w:1)
	/// Proof: `GhostSlowClaps::ApplausesForTransaction` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::NullifyNeeded` (r:1 w:0)
	/// Proof: `GhostNetworks::NullifyNeeded` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::GatekeeperAmount` (r:1 w:1)
	/// Proof: `GhostNetworks::GatekeeperAmount` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::BridgedImbalance` (r:1 w:1)
	/// Proof: `GhostNetworks::BridgedImbalance` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::AccumulatedCommission` (r:1 w:1)
	/// Proof: `GhostNetworks::AccumulatedCommission` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `System::Account` (r:1 w:1)
	/// Proof: `System::Account` (`max_values`: None, `max_size`: Some(128), added: 2603, mode: `MaxEncodedLen`)
	fn self_applause() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `655`
		//  Estimated: `4120`
		// Minimum execution time: 208_453_000 picoseconds.
		Weight::from_parts(212_038_000, 0)
			.saturating_add(Weight::from_parts(0, 4120))
			.saturating_add(RocksDbWeight::get().reads(9))
			.saturating_add(RocksDbWeight::get().writes(5))
	}
}
